/* Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.model.uinfo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

import org.dive4elements.river.backend.SessionHolder;
import org.hibernate.Query;
import org.hibernate.Session;

@Entity
@Table(name = "salix_rank")
public class SalixRank implements Serializable {

    /***** FIELDS *****/

    private static final long serialVersionUID = 7459539781698086683L;

    private Integer id;

    private String  name;

    private Double min_value;

    private Double max_value;


    /***** CONSTRUCTORS *****/

    public SalixRank() {
    }

    public SalixRank(final String name) {
        this.name = name;
    }

    /***** METHODS *****/

    @Id
    @Column(name = "id")
    public Integer getId() {
        return this.id;
    }

    public void setId(final Integer id) {
        this.id = id;
    }

    @Column(name = "name")
    public String getName() {
        return this.name;
    }

    public void setName(final String name) {
        this.name = name;
    }

    @Column(name = "min_value")
    public Double getMin_value() {
        return this.min_value;
    }

    public void setMin_value(final Double min_value) {
        this.min_value = min_value;
    }

    @Column(name = "max_value")
    public Double getMax_value() {
        return this.max_value;
    }

    public void setMax_value(final Double max_value) {
        this.max_value = max_value;
    }

    /**
     * Queries all salix ranks from the database, orders by id
     */
    public static List<SalixRank> getTypes() {
        final Session session = SessionHolder.HOLDER.get();
        final Query query = session.createQuery("FROM SalixRank ORDER BY id");
        return new ArrayList<>(query.list());
    }
}
